/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse naslparse
#define yylex   nasllex
#define yyerror naslerror
#define yylval  nasllval
#define yychar  naslchar
#define yydebug nasldebug
#define yynerrs naslnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IF = 258,
     ELSE = 259,
     EQ = 260,
     NEQ = 261,
     SUPEQ = 262,
     INFEQ = 263,
     OR = 264,
     AND = 265,
     MATCH = 266,
     NOMATCH = 267,
     REP = 268,
     FOR = 269,
     REPEAT = 270,
     UNTIL = 271,
     FOREACH = 272,
     WHILE = 273,
     BREAK = 274,
     CONTINUE = 275,
     FUNCTION = 276,
     RETURN = 277,
     INCLUDE = 278,
     LOCAL = 279,
     GLOBAL = 280,
     PLUS_PLUS = 281,
     MINUS_MINUS = 282,
     L_SHIFT = 283,
     R_SHIFT = 284,
     R_USHIFT = 285,
     EXPO = 286,
     PLUS_EQ = 287,
     MINUS_EQ = 288,
     MULT_EQ = 289,
     DIV_EQ = 290,
     MODULO_EQ = 291,
     L_SHIFT_EQ = 292,
     R_SHIFT_EQ = 293,
     R_USHIFT_EQ = 294,
     RE_MATCH = 295,
     RE_NOMATCH = 296,
     ARROW = 297,
     IDENT = 298,
     STRING1 = 299,
     STRING2 = 300,
     INTEGER = 301,
     NOT = 302,
     BIT_NOT = 303,
     UMINUS = 304
   };
#endif
#define IF 258
#define ELSE 259
#define EQ 260
#define NEQ 261
#define SUPEQ 262
#define INFEQ 263
#define OR 264
#define AND 265
#define MATCH 266
#define NOMATCH 267
#define REP 268
#define FOR 269
#define REPEAT 270
#define UNTIL 271
#define FOREACH 272
#define WHILE 273
#define BREAK 274
#define CONTINUE 275
#define FUNCTION 276
#define RETURN 277
#define INCLUDE 278
#define LOCAL 279
#define GLOBAL 280
#define PLUS_PLUS 281
#define MINUS_MINUS 282
#define L_SHIFT 283
#define R_SHIFT 284
#define R_USHIFT 285
#define EXPO 286
#define PLUS_EQ 287
#define MINUS_EQ 288
#define MULT_EQ 289
#define DIV_EQ 290
#define MODULO_EQ 291
#define L_SHIFT_EQ 292
#define R_SHIFT_EQ 293
#define R_USHIFT_EQ 294
#define RE_MATCH 295
#define RE_NOMATCH 296
#define ARROW 297
#define IDENT 298
#define STRING1 299
#define STRING2 300
#define INTEGER 301
#define NOT 302
#define BIT_NOT 303
#define UMINUS 304




/* Copy the first part of user declarations.  */
#line 3 "nasl_grammar.y"

/* Nessus Attack Scripting Language version 2
 *
 * Copyright (C) 2002 - 2004 Michel Arboi and Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2,
 * as published by the Free Software Foundation
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm

#define LNB	(((naslctxt*)parm)->line_nb)
#include "includes.h"
#include "nasl_tree.h"
#include "nasl_global_ctxt.h"
#include "nasl_func.h"
#include "nasl_var.h"
#include "nasl_lex_ctxt.h"
#include "nasl_debug.h"
#include "nasl_crypto2.h"

static void naslerror(const char *);
#define YYERROR_VERBOSE


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 39 "nasl_grammar.y"
typedef union YYSTYPE {
  int		num;
  char		*str;
  struct asciiz {
    char	*val;
    int		len;
  } data;
  tree_cell	*node;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 229 "nasl_grammar.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 241 "nasl_grammar.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  78
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1029

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  73
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  43
/* YYNRULES -- Number of rules. */
#define YYNRULES  126
/* YYNRULES -- Number of states. */
#define YYNSTATES  227

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   304

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    70,     2,     2,     2,    57,    52,     2,
      61,    62,    55,    53,    63,    54,    72,    56,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    67,    66,
      48,    47,    49,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    68,     2,    69,    51,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    64,    50,    65,    71,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    58,    59,    60
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    21,    22,
      24,    26,    30,    34,    37,    39,    42,    45,    47,    49,
      51,    53,    55,    57,    59,    61,    63,    65,    67,    69,
      71,    72,    75,    77,    83,    91,    93,    95,    97,    99,
     109,   115,   121,   128,   130,   132,   134,   135,   139,   141,
     143,   148,   153,   155,   156,   158,   162,   164,   168,   172,
     176,   180,   184,   188,   192,   196,   200,   204,   206,   208,
     210,   212,   217,   219,   222,   225,   228,   231,   235,   239,
     242,   246,   250,   254,   257,   260,   264,   268,   272,   276,
     280,   284,   288,   292,   296,   300,   302,   306,   310,   314,
     318,   322,   326,   330,   334,   338,   342,   344,   346,   348,
     350,   352,   356,   358,   362,   364,   368,   370,   372,   374,
     376,   378,   380,   382,   384,   392,   395
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      74,     0,    -1,    75,    -1,    76,    -1,    76,    75,    -1,
      82,    -1,    77,    -1,    21,   101,    61,    78,    62,    80,
      -1,    -1,    79,    -1,   101,    -1,   101,    63,    79,    -1,
      64,    81,    65,    -1,    64,    65,    -1,    82,    -1,    82,
      81,    -1,    83,    66,    -1,    80,    -1,    85,    -1,    86,
      -1,    99,    -1,   104,    -1,    92,    -1,    95,    -1,    84,
      -1,    94,    -1,   114,    -1,   115,    -1,    19,    -1,    20,
      -1,    -1,    22,   105,    -1,    22,    -1,     3,    61,   105,
      62,    82,    -1,     3,    61,   105,    62,    82,     4,    82,
      -1,    87,    -1,    88,    -1,    89,    -1,    90,    -1,    14,
      61,    91,    66,   105,    66,    91,    62,    82,    -1,    18,
      61,   105,    62,    82,    -1,    15,    82,    16,   105,    66,
      -1,    17,   101,    61,   105,    62,    82,    -1,    99,    -1,
     104,    -1,    95,    -1,    -1,    95,    13,   105,    -1,    44,
      -1,    45,    -1,    23,    61,    93,    62,    -1,   101,    61,
      96,    62,    -1,    97,    -1,    -1,    98,    -1,    98,    63,
      97,    -1,   105,    -1,   101,    67,   105,    -1,   100,    47,
     105,    -1,   100,    32,   105,    -1,   100,    33,   105,    -1,
     100,    34,   105,    -1,   100,    35,   105,    -1,   100,    36,
     105,    -1,   100,    38,   105,    -1,   100,    39,   105,    -1,
     100,    37,   105,    -1,   101,    -1,   102,    -1,    43,    -1,
      13,    -1,   101,    68,   103,    69,    -1,   105,    -1,    26,
     100,    -1,    27,   100,    -1,   100,    26,    -1,   100,    27,
      -1,    61,   105,    62,    -1,   105,    10,   105,    -1,    70,
     105,    -1,   105,     9,   105,    -1,   105,    53,   105,    -1,
     105,    54,   105,    -1,    54,   105,    -1,    71,   105,    -1,
     105,    55,   105,    -1,   105,    31,   105,    -1,   105,    56,
     105,    -1,   105,    57,   105,    -1,   105,    52,   105,    -1,
     105,    51,   105,    -1,   105,    50,   105,    -1,   105,    29,
     105,    -1,   105,    30,   105,    -1,   105,    28,   105,    -1,
     104,    -1,   105,    11,   105,    -1,   105,    12,   105,    -1,
     105,    40,    93,    -1,   105,    41,    93,    -1,   105,    48,
     105,    -1,   105,    49,   105,    -1,   105,     5,   105,    -1,
     105,     6,   105,    -1,   105,     7,   105,    -1,   105,     8,
     105,    -1,   111,    -1,    99,    -1,   113,    -1,   109,    -1,
     106,    -1,    68,   107,    69,    -1,   108,    -1,   108,    63,
     107,    -1,   110,    -1,    93,    42,   110,    -1,    46,    -1,
      45,    -1,    44,    -1,   109,    -1,   112,    -1,   102,    -1,
      95,    -1,   101,    -1,    46,    72,    46,    72,    46,    72,
      46,    -1,    24,    78,    -1,    25,    78,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   131,   131,   136,   142,   149,   149,   152,   160,   160,
     161,   162,   170,   170,   171,   172,   186,   186,   186,   186,
     189,   189,   189,   190,   190,   190,   190,   190,   191,   195,
     199,   202,   208,   215,   221,   229,   229,   229,   229,   230,
     240,   247,   255,   264,   264,   264,   264,   267,   275,   275,
     278,   311,   318,   318,   319,   319,   325,   331,   339,   343,
     344,   345,   346,   347,   348,   349,   350,   353,   353,   355,
     355,   357,   364,   367,   368,   369,   370,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   403,   403,   403,
     403,   406,   408,   409,   413,   416,   422,   423,   427,   432,
     434,   435,   435,   437,   439,   449,   457
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IF", "ELSE", "EQ", "NEQ", "SUPEQ",
  "INFEQ", "OR", "AND", "MATCH", "NOMATCH", "REP", "FOR", "REPEAT",
  "UNTIL", "FOREACH", "WHILE", "BREAK", "CONTINUE", "FUNCTION", "RETURN",
  "INCLUDE", "LOCAL", "GLOBAL", "PLUS_PLUS", "MINUS_MINUS", "L_SHIFT",
  "R_SHIFT", "R_USHIFT", "EXPO", "PLUS_EQ", "MINUS_EQ", "MULT_EQ",
  "DIV_EQ", "MODULO_EQ", "L_SHIFT_EQ", "R_SHIFT_EQ", "R_USHIFT_EQ",
  "RE_MATCH", "RE_NOMATCH", "ARROW", "IDENT", "STRING1", "STRING2",
  "INTEGER", "'='", "'<'", "'>'", "'|'", "'^'", "'&'", "'+'", "'-'", "'*'",
  "'/'", "'%'", "NOT", "BIT_NOT", "UMINUS", "'('", "')'", "','", "'{'",
  "'}'", "';'", "':'", "'['", "']'", "'!'", "'~'", "'.'", "$accept",
  "tiptop", "instr_decl_list", "instr_decl", "func_decl", "arg_decl",
  "arg_decl_1", "block", "instr_list", "instr", "simple_instr", "ret",
  "if_block", "loop", "for_loop", "while_loop", "repeat_loop",
  "foreach_loop", "aff_func", "rep", "string", "inc", "func_call",
  "arg_list", "arg_list_1", "arg", "aff", "lvalue", "identifier",
  "array_elem", "array_index", "post_pre_incr", "expr", "const_array",
  "list_array_data", "array_data", "atom", "simple_array_data", "var",
  "var_name", "ipaddr", "loc", "glob", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    61,    60,    62,
     124,    94,    38,    43,    45,    42,    47,    37,   302,   303,
     304,    40,    41,    44,   123,   125,    59,    58,    91,    93,
      33,   126,    46
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    73,    74,    75,    75,    76,    76,    77,    78,    78,
      79,    79,    80,    80,    81,    81,    82,    82,    82,    82,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
      83,    84,    84,    85,    85,    86,    86,    86,    86,    87,
      88,    89,    90,    91,    91,    91,    91,    92,    93,    93,
      94,    95,    96,    96,    97,    97,    98,    98,    99,    99,
      99,    99,    99,    99,    99,    99,    99,   100,   100,   101,
     101,   102,   103,   104,   104,   104,   104,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   106,   107,   107,   108,   108,   109,   109,   109,   110,
     111,   111,   111,   112,   113,   114,   115
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     6,     0,     1,
       1,     3,     3,     2,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     1,     5,     7,     1,     1,     1,     1,     9,
       5,     5,     6,     1,     1,     1,     0,     3,     1,     1,
       4,     4,     1,     0,     1,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     4,     1,     2,     2,     2,     2,     3,     3,     2,
       3,     3,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     7,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      30,     0,    70,     0,    30,     0,     0,    28,    29,     0,
      32,     0,     8,     8,     0,     0,    69,    30,     0,     2,
       3,     6,    17,     5,     0,    24,    18,    19,    35,    36,
      37,    38,    22,    25,    23,    20,     0,    67,    68,    21,
      26,    27,     0,    46,     0,     0,     0,     0,   118,   117,
     116,     0,     0,     0,     0,     0,   122,   107,   123,   121,
      95,    31,   110,   109,   106,   120,   108,     0,   125,     9,
      10,   126,    73,    67,    74,    13,     0,    14,     1,     4,
      16,     0,    75,    76,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,     0,    45,    43,    44,
       0,     0,     0,     8,     0,    83,     0,   118,   117,   116,
       0,     0,   112,   119,   114,    79,    84,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,    49,     0,     0,    12,    15,    47,    59,    60,
      61,    62,    63,    66,    64,    65,    58,     0,    52,    54,
     123,    56,     0,    72,    30,     0,     0,     0,    30,     0,
       0,    77,     0,   111,     0,   102,   103,   104,   105,    80,
      78,    96,    97,    94,    92,    93,    86,    98,    99,   100,
     101,    91,    90,    89,    81,    82,    85,    87,    88,    50,
      11,    51,     0,     0,    71,    33,     0,    41,    30,    40,
       0,     0,   115,   113,    55,    57,    30,    46,    42,     7,
       0,    34,     0,     0,    30,   124,    39
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    18,    19,    20,    21,    68,    69,    22,    76,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    96,    32,
     110,    33,    56,   157,   158,   159,    57,    36,    58,    59,
     162,    60,   161,    62,   111,   112,    63,   114,    64,    65,
      66,    40,    41
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -91
static const short yypact[] =
{
     464,   -53,   -91,   -50,   491,    -6,   -42,   -91,   -91,    -6,
     499,   -40,    -6,    -6,    -6,    -6,   -91,   259,    25,   -91,
      91,   -91,   -91,   -91,   -39,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,   -91,    23,   -91,   553,   -13,   -91,   -91,
     -91,   -91,   499,    26,    29,   -30,   499,   -21,   -91,   -91,
     -18,   499,   499,    13,   499,   499,   -91,   -91,   961,   611,
     -91,   798,   -91,   -91,   -91,   -91,   -91,    19,   -91,   -91,
     -12,   -91,   -91,   -26,   -91,   -91,    -9,   123,   -91,   -91,
     -91,   499,   -91,   -91,   499,   499,   499,   499,   499,   499,
     499,   499,   499,   499,   499,   566,    -4,   -91,   -91,   -91,
     499,   499,   624,    -6,    14,    37,   682,    39,    40,   -91,
      42,     7,    22,   -91,   -91,    37,    37,   499,   499,   499,
     499,   499,   499,   499,   499,   499,   499,   499,   499,    19,
      19,   499,   499,   499,   499,   499,   499,   499,   499,   499,
     499,   -91,   -91,    28,    -6,   -91,   -91,   798,   798,   798,
     798,   798,   798,   798,   798,   798,   798,    35,   -91,    33,
     945,   798,    17,   798,   491,   499,   347,   740,   491,    36,
      16,   -91,    34,   -91,    13,   882,   882,   882,   882,   851,
     913,   882,   882,   398,   398,   398,    37,   -91,   -91,   882,
     882,   354,   337,   415,    15,    15,    37,    37,    37,   -91,
     -91,   -91,   499,   499,   -91,    83,   409,   -91,   491,   -91,
      27,    53,   -91,   -91,   -91,   798,   491,    26,   -91,   -91,
      47,   -91,    38,    56,   491,   -91,   -91
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
     -91,   -91,   101,   -91,   -91,   -11,   -20,   -87,    48,    12,
     -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   -90,   -91,
     -64,   -91,     6,   -91,   -74,   -91,    24,    60,     0,    18,
     -91,    30,   209,   -91,   -45,   -91,   -52,   -41,   -91,   -91,
     -91,   -91,   -91
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -69
static const short yytable[] =
{
      37,   113,    71,   143,    37,    45,    34,     2,    42,    47,
      34,    43,    70,    70,    73,    73,    44,    37,    38,    46,
      37,    67,    38,    34,    35,    78,    34,    80,    35,    77,
      39,   101,    38,    38,    39,    38,    81,    16,    38,     2,
     103,    35,    94,    37,    35,   100,   128,    39,    93,    97,
      39,   144,    14,    15,   104,    94,   145,   107,   108,   109,
     170,    38,   165,   141,   142,   187,   188,    98,   128,    16,
     138,   139,   140,    99,    72,    74,   173,    37,    48,    49,
     109,   -48,   -49,    34,   172,   174,   204,   216,   211,    77,
     199,    17,   169,   160,     1,    38,   202,   201,   210,   220,
     224,    35,   225,    70,     2,     3,     4,    39,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,   223,
     113,    79,   113,   219,   200,   146,     1,   222,   214,   213,
       0,   212,     0,     0,    16,     0,     2,     3,     4,     0,
       5,     6,     7,     8,    70,    10,    11,    12,    13,    14,
      15,     0,     0,     0,     0,    17,     0,   -30,     0,     0,
       0,     0,     0,     0,    37,     0,    16,     0,    37,     0,
      34,     0,     0,     0,    34,     0,   205,     0,     0,     0,
     209,     0,    38,     0,     0,     0,    38,    17,    35,   -30,
       0,     0,    35,     0,    39,     0,     0,     0,    39,     0,
       0,     0,   160,     0,     0,     0,     0,     0,    37,     0,
       0,     0,     0,     0,    34,     0,    37,    37,     0,    61,
     218,     0,    34,    97,    37,     0,    38,     0,   221,     0,
      34,     0,    35,     0,    38,    38,   226,     0,    39,     0,
      35,    98,    38,     0,     0,     0,    39,    99,    35,     0,
       0,    95,     0,     0,    39,   102,     0,     0,     0,     0,
     105,   106,     1,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     0,     5,     6,     7,     8,
       0,    10,    11,    12,    13,    14,    15,     0,     0,     0,
     147,     0,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    16,   163,     0,     0,     0,     0,     0,   166,
     167,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    17,    75,     0,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
       0,     0,   117,   118,   119,   120,   121,   122,   123,   124,
       0,     0,     0,     0,     0,   125,   126,   127,   128,     0,
       0,     0,     0,     0,   206,   125,   126,   127,   128,     0,
       0,     0,   125,   126,   127,   128,     0,   129,   130,   135,
     136,   137,   138,   139,   140,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   134,   135,   136,   137,   138,
     139,   140,   215,   207,   117,   118,   119,   120,   121,   122,
     123,   124,     0,     0,     0,     0,   -69,   -69,   -69,   128,
       0,     0,     0,     0,     0,     0,     0,   125,   126,   127,
     128,     0,     0,   125,   126,   127,   128,     0,     0,   129,
     130,   136,   137,   138,   139,   140,     0,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,     1,   136,   137,
     138,   139,   140,     0,     0,   217,     0,     2,     3,     4,
       0,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,     0,     0,     1,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     3,     4,    16,     5,     6,
       7,     8,     2,    10,    11,    12,    13,    14,    15,     0,
       0,     0,     0,     0,     0,    14,    15,     0,    17,     0,
       0,     0,     0,     0,    16,     0,     0,     0,     0,     0,
       0,     0,    16,    48,    49,    50,     0,     0,     0,     0,
       0,     0,     0,    51,     0,    17,     0,     0,     0,     0,
      52,     0,     0,     0,     0,     0,     0,    53,     0,    54,
      55,   117,   118,   119,   120,   121,   122,   123,   124,    82,
      83,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,   125,   126,   127,   128,     0,     0,
      92,     0,     0,     0,     0,     0,   129,   130,     0,     0,
       0,     0,     0,     0,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,     0,     0,     0,     0,   164,   117,
     118,   119,   120,   121,   122,   123,   124,   -68,   -68,     0,
       0,     0,     0,   -68,   -68,   -68,   -68,   -68,   -68,   -68,
     -68,     0,   125,   126,   127,   128,     0,     0,   -68,     0,
       0,     0,     0,     0,   129,   130,     0,     0,     0,     0,
       0,     0,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   168,   117,   118,   119,
     120,   121,   122,   123,   124,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     125,   126,   127,   128,     0,     0,     0,     0,     0,     0,
       0,     0,   129,   130,     0,     0,     0,     0,     0,     0,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,     0,     0,     0,   171,   117,   118,   119,   120,   121,
     122,   123,   124,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   125,   126,
     127,   128,     0,     0,     0,     0,     0,     0,     0,     0,
     129,   130,     0,     0,     0,     0,     0,     0,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,     0,     0,
       0,     0,   208,   117,   118,   119,   120,   121,   122,   123,
     124,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   125,   126,   127,   128,
       0,     0,     0,     0,     0,     0,     0,     0,   129,   130,
       0,     0,     0,     0,     0,     0,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   117,   118,   119,   120,
       0,   122,   123,   124,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   125,
     126,   127,   128,     0,     0,     0,     0,   -69,   -69,   -69,
     -69,   129,   130,   -69,   -69,     0,     0,     0,     0,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,     0,
     125,   126,   127,   128,     0,     0,     0,     0,   117,   118,
     119,   120,   -69,   -69,   123,   124,     0,     0,     0,     0,
     -69,   -69,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   125,   126,   127,   128,     0,     0,     0,     0,     0,
       0,     0,     0,   129,   130,     0,     0,     0,     0,     0,
       0,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   -67,   -67,     0,     0,     0,     0,   -67,   -67,   -67,
     -67,   -67,   -67,   -67,   -67,     0,     0,   -67,   -67,     0,
       0,     0,   -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,
     -67,     0,     0,     0,     0,     0,    93,     0,   -67,     0,
       0,     0,   203,    94,     0,     0,     0,     0,     0,     0,
       0,     0,    93,     0,     0,     0,     0,     0,     0,    94
};

static const short yycheck[] =
{
       0,    53,    13,    67,     4,     5,     0,    13,    61,     9,
       4,    61,    12,    13,    14,    15,     4,    17,     0,    61,
      20,    61,     4,    17,     0,     0,    20,    66,     4,    17,
       0,    61,    14,    15,     4,    17,    13,    43,    20,    13,
      61,    17,    68,    43,    20,    16,    31,    17,    61,    43,
      20,    63,    26,    27,    72,    68,    65,    44,    45,    46,
      46,    43,    66,    44,    45,   129,   130,    43,    31,    43,
      55,    56,    57,    43,    14,    15,    69,    77,    44,    45,
      46,    42,    42,    77,    42,    63,    69,     4,    72,    77,
      62,    64,   103,    93,     3,    77,    63,    62,    62,    46,
      62,    77,    46,   103,    13,    14,    15,    77,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    72,
     172,    20,   174,   210,   144,    77,     3,   217,   202,   174,
      -1,   172,    -1,    -1,    43,    -1,    13,    14,    15,    -1,
      17,    18,    19,    20,   144,    22,    23,    24,    25,    26,
      27,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,   164,    -1,    43,    -1,   168,    -1,
     164,    -1,    -1,    -1,   168,    -1,   164,    -1,    -1,    -1,
     168,    -1,   164,    -1,    -1,    -1,   168,    64,   164,    66,
      -1,    -1,   168,    -1,   164,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,   208,    -1,
      -1,    -1,    -1,    -1,   208,    -1,   216,   217,    -1,    10,
     208,    -1,   216,   217,   224,    -1,   208,    -1,   216,    -1,
     224,    -1,   208,    -1,   216,   217,   224,    -1,   208,    -1,
     216,   217,   224,    -1,    -1,    -1,   216,   217,   224,    -1,
      -1,    42,    -1,    -1,   224,    46,    -1,    -1,    -1,    -1,
      51,    52,     3,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    17,    18,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      81,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    43,    94,    -1,    -1,    -1,    -1,    -1,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    65,    -1,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,   165,    28,    29,    30,    31,    -1,
      -1,    -1,    28,    29,    30,    31,    -1,    40,    41,    52,
      53,    54,    55,    56,    57,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    51,    52,    53,    54,    55,
      56,    57,   203,    66,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    -1,    -1,    28,    29,    30,    31,    -1,    -1,    40,
      41,    53,    54,    55,    56,    57,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,     3,    53,    54,
      55,    56,    57,    -1,    -1,    66,    -1,    13,    14,    15,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    43,    17,    18,
      19,    20,    13,    22,    23,    24,    25,    26,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    26,    27,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    64,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    70,
      71,     5,     6,     7,     8,     9,    10,    11,    12,    26,
      27,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    28,    29,    30,    31,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,     5,
       6,     7,     8,     9,    10,    11,    12,    26,    27,    -1,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    28,    29,    30,    31,    -1,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    40,    41,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    -1,    -1,    -1,    62,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    -1,    -1,    -1,    62,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    -1,
      -1,    -1,    62,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,     5,     6,     7,     8,
      -1,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,    40,    41,    11,    12,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,     5,     6,
       7,     8,    40,    41,    11,    12,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    26,    27,    -1,    -1,    -1,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    -1,    26,    27,    -1,
      -1,    -1,    47,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    -1,    -1,    -1,    -1,    61,    -1,    47,    -1,
      -1,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    68
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    13,    14,    15,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    43,    64,    74,    75,
      76,    77,    80,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    92,    94,    95,    99,   100,   101,   102,   104,
     114,   115,    61,    61,    82,   101,    61,   101,    44,    45,
      46,    54,    61,    68,    70,    71,    95,    99,   101,   102,
     104,   105,   106,   109,   111,   112,   113,    61,    78,    79,
     101,    78,   100,   101,   100,    65,    81,    82,     0,    75,
      66,    13,    26,    27,    32,    33,    34,    35,    36,    37,
      38,    39,    47,    61,    68,   105,    91,    95,    99,   104,
      16,    61,   105,    61,    72,   105,   105,    44,    45,    46,
      93,   107,   108,   109,   110,   105,   105,     5,     6,     7,
       8,     9,    10,    11,    12,    28,    29,    30,    31,    40,
      41,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    44,    45,    93,    63,    65,    81,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,    96,    97,    98,
     101,   105,   103,   105,    62,    66,   105,   105,    62,    78,
      46,    62,    42,    69,    63,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,    93,    93,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,    62,
      79,    62,    63,    67,    69,    82,   105,    66,    62,    82,
      62,    72,   110,   107,    97,   105,     4,    66,    82,    80,
      46,    82,    91,    72,    62,    46,    82
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 132 "nasl_grammar.y"
    {
	  ((naslctxt*)parm)->tree = yyvsp[0].node;
	;}
    break;

  case 3:
#line 137 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_INSTR_L;
	  yyval.node->link[0] = yyvsp[0].node;
	;}
    break;

  case 4:
#line 143 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_INSTR_L;
	  yyval.node->link[0] = yyvsp[-1].node;
	  yyval.node->link[1] = yyvsp[0].node;
	;}
    break;

  case 7:
#line 153 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, yyvsp[-4].str);
	  yyval.node->type = NODE_FUN_DEF;
	  yyval.node->link[0] = yyvsp[-2].node;
	  yyval.node->link[1] = yyvsp[0].node;
	;}
    break;

  case 8:
#line 160 "nasl_grammar.y"
    { yyval.node = NULL; ;}
    break;

  case 9:
#line 160 "nasl_grammar.y"
    { yyval.node = yyvsp[0].node; ;}
    break;

  case 10:
#line 161 "nasl_grammar.y"
    { yyval.node = alloc_tree_cell(LNB, yyvsp[0].str); yyval.node->type = NODE_DECL; ;}
    break;

  case 11:
#line 163 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, yyvsp[-2].str);
	  yyval.node->type = NODE_DECL;
	  yyval.node->link[0] = yyvsp[0].node; 
	;}
    break;

  case 12:
#line 170 "nasl_grammar.y"
    { yyval.node = yyvsp[-1].node; ;}
    break;

  case 13:
#line 170 "nasl_grammar.y"
    { yyval.node = NULL; ;}
    break;

  case 15:
#line 173 "nasl_grammar.y"
    {
	  if (yyvsp[-1].node == NULL)
	    yyval.node = yyvsp[0].node;
	  else
	    {
	      yyval.node = alloc_tree_cell(LNB, NULL);
	      yyval.node->type = NODE_INSTR_L;
	      yyval.node->link[0] = yyvsp[-1].node;
	      yyval.node->link[1] = yyvsp[0].node; 
	    }
	;}
    break;

  case 16:
#line 186 "nasl_grammar.y"
    { yyval.node = yyvsp[-1].node; ;}
    break;

  case 28:
#line 191 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type =  NODE_BREAK;
	;}
    break;

  case 29:
#line 195 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type =  NODE_CONTINUE;
	;}
    break;

  case 30:
#line 199 "nasl_grammar.y"
    { yyval.node = NULL; ;}
    break;

  case 31:
#line 203 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type =  NODE_RETURN;
	  yyval.node->link[0] = yyvsp[0].node;
	;}
    break;

  case 32:
#line 209 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type =  NODE_RETURN;
	;}
    break;

  case 33:
#line 216 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_IF_ELSE;
	  yyval.node->link[0] = yyvsp[-2].node; yyval.node->link[1] = yyvsp[0].node;
	;}
    break;

  case 34:
#line 222 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_IF_ELSE;
	  yyval.node->link[0] = yyvsp[-4].node; yyval.node->link[1] = yyvsp[-2].node; yyval.node->link[2] = yyvsp[0].node;
	;}
    break;

  case 39:
#line 231 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_FOR;
	  yyval.node->link[0] = yyvsp[-6].node;
	  yyval.node->link[1] = yyvsp[-4].node;
	  yyval.node->link[2] = yyvsp[-2].node;
	  yyval.node->link[3] = yyvsp[0].node;
	;}
    break;

  case 40:
#line 241 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_WHILE;
	  yyval.node->link[0] = yyvsp[-2].node;
	  yyval.node->link[1] = yyvsp[0].node;
	;}
    break;

  case 41:
#line 248 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_REPEAT_UNTIL;
	  yyval.node->link[0] = yyvsp[-3].node;
	  yyval.node->link[1] = yyvsp[-1].node;
	;}
    break;

  case 42:
#line 256 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, yyvsp[-4].str);
	  yyval.node->type = NODE_FOREACH;
	  yyval.node->link[0] = yyvsp[-2].node;
	  yyval.node->link[1] = yyvsp[0].node;
	;}
    break;

  case 46:
#line 264 "nasl_grammar.y"
    { yyval.node = NULL; ;}
    break;

  case 47:
#line 268 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_REPEATED;
	  yyval.node->link[0] = yyvsp[-2].node;
	  yyval.node->link[1] = yyvsp[0].node;
	;}
    break;

  case 48:
#line 275 "nasl_grammar.y"
    { yyval.str = yyvsp[0].data.val; ;}
    break;

  case 50:
#line 279 "nasl_grammar.y"
    { 
	  naslctxt	subctx;
	  int		x;

 	  subctx.always_authenticated = ((naslctxt*)parm)->always_authenticated;
	  x = init_nasl_ctx(&subctx, yyvsp[-1].str);
	  yyval.node = NULL;
	  if (x >= 0)
	    {
	      if (! naslparse(&subctx))
		{
		  yyval.node = subctx.tree;
		}
	      else
		nasl_perror(NULL, "%s: Parse error at or near line %d\n",
			yyvsp[-1].str, subctx.line_nb);
	      efree(&subctx.buffer);
	      fclose(subctx.fp); 
	      subctx.fp = NULL;
	      /* If we are an authenticated script and the script we include is *NOT* authenticated,
   		 then we lose our authentication status */
	      if ( ((naslctxt*)parm)->always_authenticated == 0 &&
	          ((naslctxt*)parm)->authenticated != 0 && subctx.authenticated == 0 )
			{
			((naslctxt*)parm)->authenticated = 0;
			nasl_perror(NULL, "Including %s which is not authenticated - losing our authenticated status\n", yyvsp[-1].str);
			}
	    }
	  efree(& yyvsp[-1].str);
	;}
    break;

  case 51:
#line 312 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, yyvsp[-3].str);
	  yyval.node->type = NODE_FUN_CALL;
	  yyval.node->link[0] = yyvsp[-1].node;
	;}
    break;

  case 53:
#line 318 "nasl_grammar.y"
    { yyval.node = NULL; ;}
    break;

  case 55:
#line 320 "nasl_grammar.y"
    {
	  yyvsp[-2].node->link[1] = yyvsp[0].node;
	  yyval.node = yyvsp[-2].node;
	;}
    break;

  case 56:
#line 326 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_ARG;
	  yyval.node->link[0] = yyvsp[0].node;
	;}
    break;

  case 57:
#line 332 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, yyvsp[-2].str);
	  yyval.node->type = NODE_ARG;
	  yyval.node->link[0] = yyvsp[0].node;
	;}
    break;

  case 58:
#line 340 "nasl_grammar.y"
    {
	  yyval.node = alloc_expr_cell(LNB, NODE_AFF, yyvsp[-2].node, yyvsp[0].node);
	;}
    break;

  case 59:
#line 343 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_PLUS_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 60:
#line 344 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_MINUS_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 61:
#line 345 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_MULT_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 62:
#line 346 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_DIV_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 63:
#line 347 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_MODULO_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 64:
#line 348 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_R_SHIFT_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 65:
#line 349 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_R_USHIFT_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 66:
#line 350 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, NODE_L_SHIFT_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 67:
#line 353 "nasl_grammar.y"
    { yyval.node = alloc_tree_cell(LNB, yyvsp[0].str); yyval.node->type = NODE_VAR; ;}
    break;

  case 70:
#line 355 "nasl_grammar.y"
    { yyval.str = strdup("x"); ;}
    break;

  case 71:
#line 358 "nasl_grammar.y"
    {
	  yyval.node = alloc_tree_cell(LNB, yyvsp[-3].str);
	  yyval.node->type = NODE_ARRAY_EL;
	  yyval.node->link[0] = yyvsp[-1].node;
	;}
    break;

  case 73:
#line 367 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_INCR, NULL, yyvsp[0].node); ;}
    break;

  case 74:
#line 368 "nasl_grammar.y"
    {yyval.node = alloc_expr_cell(LNB, EXPR_DECR, NULL, yyvsp[0].node); ;}
    break;

  case 75:
#line 369 "nasl_grammar.y"
    { yyval.node= alloc_expr_cell(LNB, EXPR_INCR, yyvsp[-1].node, NULL); ;}
    break;

  case 76:
#line 370 "nasl_grammar.y"
    { yyval.node= alloc_expr_cell(LNB, EXPR_DECR, yyvsp[-1].node, NULL); ;}
    break;

  case 77:
#line 374 "nasl_grammar.y"
    { yyval.node = yyvsp[-1].node; ;}
    break;

  case 78:
#line 375 "nasl_grammar.y"
    {  yyval.node = alloc_expr_cell(LNB, EXPR_AND, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 79:
#line 376 "nasl_grammar.y"
    {  yyval.node = alloc_expr_cell(LNB, EXPR_NOT, yyvsp[0].node, NULL); ;}
    break;

  case 80:
#line 377 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_OR, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 81:
#line 378 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_PLUS, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 82:
#line 379 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_MINUS, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 83:
#line 380 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_U_MINUS, yyvsp[0].node, NULL);;}
    break;

  case 84:
#line 381 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_BIT_NOT, yyvsp[0].node, NULL);;}
    break;

  case 85:
#line 382 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_MULT, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 86:
#line 383 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_EXPO, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 87:
#line 384 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_DIV, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 88:
#line 385 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_MODULO, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 89:
#line 386 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_BIT_AND, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 90:
#line 387 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_BIT_XOR, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 91:
#line 388 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_BIT_OR, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 92:
#line 389 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_R_SHIFT, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 93:
#line 390 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_R_USHIFT, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 94:
#line 391 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, EXPR_L_SHIFT, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 96:
#line 393 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_MATCH, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 97:
#line 394 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_NOMATCH, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 98:
#line 395 "nasl_grammar.y"
    { yyval.node = alloc_RE_cell(LNB, COMP_RE_MATCH, yyvsp[-2].node, yyvsp[0].str); ;}
    break;

  case 99:
#line 396 "nasl_grammar.y"
    { yyval.node = alloc_RE_cell(LNB, COMP_RE_NOMATCH, yyvsp[-2].node, yyvsp[0].str); ;}
    break;

  case 100:
#line 397 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_LT, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 101:
#line 398 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_GT, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 102:
#line 399 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_EQ, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 103:
#line 400 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_NE, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 104:
#line 401 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_GE, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 105:
#line 402 "nasl_grammar.y"
    { yyval.node = alloc_expr_cell(LNB, COMP_LE, yyvsp[-2].node, yyvsp[0].node); ;}
    break;

  case 111:
#line 406 "nasl_grammar.y"
    { yyval.node = make_array_from_elems(yyvsp[-1].node); ;}
    break;

  case 112:
#line 408 "nasl_grammar.y"
    { yyval.node = yyvsp[0].node; ;}
    break;

  case 113:
#line 409 "nasl_grammar.y"
    {
		yyvsp[-2].node->link[1] = yyvsp[0].node; yyval.node = yyvsp[-2].node;
	;}
    break;

  case 114:
#line 413 "nasl_grammar.y"
    { 
	  yyval.node = alloc_typed_cell(ARRAY_ELEM); 
	  yyval.node->link[0] = yyvsp[0].node;
	;}
    break;

  case 115:
#line 416 "nasl_grammar.y"
    {
	  yyval.node = alloc_typed_cell(ARRAY_ELEM);
	  yyval.node->link[0] = yyvsp[0].node;
	  yyval.node->x.str_val = yyvsp[-2].str;
	;}
    break;

  case 116:
#line 422 "nasl_grammar.y"
    {  yyval.node = alloc_typed_cell(CONST_INT); yyval.node->x.i_val = yyvsp[0].num; ;}
    break;

  case 117:
#line 423 "nasl_grammar.y"
    { 
	  yyval.node = alloc_typed_cell(CONST_STR); yyval.node->x.str_val = yyvsp[0].str;
	  yyval.node->size = strlen(yyvsp[0].str);
	;}
    break;

  case 118:
#line 427 "nasl_grammar.y"
    { 
	  yyval.node = alloc_typed_cell(CONST_DATA); yyval.node->x.str_val = yyvsp[0].data.val;
	  yyval.node->size = yyvsp[0].data.len;
	;}
    break;

  case 120:
#line 434 "nasl_grammar.y"
    { yyval.node = alloc_tree_cell(LNB, yyvsp[0].str); yyval.node->type = NODE_VAR; ;}
    break;

  case 124:
#line 440 "nasl_grammar.y"
    {
	  char	*s = emalloc(44);
	  snprintf(s, 44, "%d.%d.%d.%d", yyvsp[-6].num, yyvsp[-4].num, yyvsp[-2].num, yyvsp[0].num);
	  yyval.node = alloc_tree_cell(LNB, s);
	  yyval.node->type = CONST_STR;
	  yyval.node->size = strlen(s);
	;}
    break;

  case 125:
#line 450 "nasl_grammar.y"
    { 
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_LOCAL;
	  yyval.node->link[0] = yyvsp[0].node;
	;}
    break;

  case 126:
#line 458 "nasl_grammar.y"
    { 
	  yyval.node = alloc_tree_cell(LNB, NULL);
	  yyval.node->type = NODE_GLOBAL;
	  yyval.node->link[0] = yyvsp[0].node;
	;}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2099 "nasl_grammar.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 464 "nasl_grammar.y"


#include <stdio.h>
#include <stdlib.h>

static void 
naslerror(const char *s)
{
  fputs(s, stderr);
}


int
init_nasl_ctx(naslctxt* pc, const char* name)
{
  char line[1024];
  char full_name[MAXPATHLEN];
#ifdef MULTIPLE_INCLUDE_DIRS
  static const char* inc_dirs[] = { ".", "/tmp" }; /* TBD */
#endif
  pc->line_nb = 1;
  pc->tree = NULL;
  pc->buffer = emalloc(80);
  pc->maxlen = 80;
  pc->authenticated = 0;

#ifdef MULTIPLE_INCLUDE_DIRS
  if (name[0] == '/')		/* absolute path */
#endif
    {
      /* Shouldn't we reject the file? */
      if ((pc->fp = fopen(name, "r")) == NULL)
	{
	  perror(name);
	  return -1;
	}
      strncpy(full_name, name, sizeof(full_name) - 1);
      goto authenticate;
    }
#ifdef MULTIPLE_INCLUDE_DIRS
  else
    {
      int	i;

      for (i = 0; i < sizeof(inc_dirs) / sizeof(*inc_dirs); i ++)
	{
	  snprintf(full_name, sizeof(full_name),  "%s/%s", inc_dirs[i], name);
	  if ((pc->fp = fopen(full_name, "r")) != NULL)
	    goto authenticate;
	  perror(full_name);
	}
      return -1;
    }
#endif

authenticate:
 if ( pc->always_authenticated )
	pc->authenticated = 1;
 else 
 {
 fgets(line, sizeof(line) - 1, pc->fp);
 line[sizeof(line) - 1] = '\0';
 if ( strncmp(line, "#TRUSTED", strlen("#TRUSTED") ) == 0 )
 {
  int sig;
  full_name[sizeof(full_name) - 1] = '\0';
  sig = verify_script_signature(full_name);
  if ( sig == 0 ) 
	pc->authenticated = 1;
  else
	pc->authenticated = 0;
 
  if ( sig > 0  ) 
	{
	  fprintf(stderr, "%s: bad signature. Will not execute this script\n", full_name);
	  fclose(pc->fp);
	  pc->fp = NULL;
	  return -1;
	}
   else if ( sig < 0 )
	  fprintf(stderr, "%s: Could not verify the signature - this script will be run in non-authenticated mode\n", full_name);
 }
 rewind(pc->fp);
 }
 return 0;
}

void
nasl_clean_ctx(naslctxt* c)
{
#if 0
  nasl_dump_tree(c->tree);
#endif
  deref_cell(c->tree);
  efree(&c->buffer);
  if (c->fp)
    {
      fclose(c->fp);
      c->fp = NULL;
    }
}


#if 0
int
main(int argc,char **argv)
{
  naslctxt	ctx;

  ctx.line_nb = 1;
  ctx.tree = NULL;
  if (argc != 2)
    {
      nasl_perror(NULL, "Usage : nasl <input_file>\n");
      return 1;
    }
  if ((ctx.fp = fopen(argv[1], "r")) == NULL)
    {
      perror(argv[1]);
      return 1;
    }

  return naslparse((void*) &ctx);
}
#endif

enum lex_state {
  ST_START = 0,
  ST_SPACE,
  ST_IDENT,
  ST_ZERO,
  ST_ZEROX,
  ST_OCT,
  ST_DEC,
  ST_HEX,
  ST_COMMENT,
  ST_SUP,
  ST_INF,
  ST_SUP_EXCL,  
  ST_STRING1,
  ST_STRING1_ESC,
  ST_STRING2,
  ST_PLUS,
  ST_MINUS,
  ST_MULT,
  ST_DIV,
  ST_MODULO,
  ST_R_SHIFT,
  ST_R_USHIFT,
  ST_L_SHIFT,
  ST_NOT,
  ST_EQ,
  ST_AND,
  ST_OR };

static int
mylex(lvalp, parm)
     YYSTYPE *lvalp;
     void	*parm;
{
  char		*p;
  naslctxt	*ctx = parm;
  FILE		*fp;
  int		c, st = ST_START, len, r;
  int		x, i;

  if ( parm == NULL )
	return -1;

  fp = ctx->fp;
  p = ctx->buffer;
  len = 0;

  while ((c = getc(fp)) != EOF)
    {
      if (c ==  '\n')
	ctx->line_nb ++;

      switch(st)
	{
	case ST_START:
	  if (c == '#')
	    st = ST_COMMENT;
	  else if (isalpha(c) || c == '_')
	    {
	      st = ST_IDENT;
	      *p++ = c;
	      len ++;
	    }
	  else if (isspace(c))
	    st = ST_SPACE;
	  else if (c == '0')
	    st = ST_ZERO;
	  else if (isdigit(c))
	    {
	      st = ST_DEC;
	      *p++ = c;
	      len ++;
	    }
	  else if (c == '\'')
	    st = ST_STRING1;
	  else if (c == '"')
	    st = ST_STRING2;
	  else if (c == '+')
	    st = ST_PLUS;
	  else if (c == '-')
	    st = ST_MINUS;
	  else if (c == '*')
	    st = ST_MULT;
	  else if (c == '/')
	    st = ST_DIV;
	  else if (c == '%')
	    st = ST_MODULO;
	  else if (c == '>')
	    st =  ST_SUP;
	  else if (c == '<')
	    st = ST_INF;
	  else if (c == '=')
	    st = ST_EQ;
	  else if (c == '|')
	    st = ST_OR;
	  else if (c == '!')
	    st = ST_NOT;
	  else if (c == '&')
	    st = ST_AND;
	  else
	    {
	      return c;
	    }
	  break;

	case ST_STRING2:
	  if (c == '"')
	    goto exit_loop;
	  *p++ = c;
	  len ++;
	  break;

	case ST_STRING1:
	  if (c == '\'')
	    goto exit_loop;
	  else if (c == '\\')
	    {
	      c = getc(fp);
	      switch (c)
		{
		case EOF:
		  nasl_perror(NULL, "Unfinished string\n");
		  goto exit_loop; /* parse error? */

		case '\n':	/* escaped end of line */
		  ctx->line_nb ++;
		  break;
		case '\\':
		  *p++ ='\\'; len ++;
		  break;
		case 'n':
		  *p++ = '\n'; len++;
		  break;
		case 'f':
		  *p++ = '\f'; len ++;
		  break;
		case 't':
		  *p++ = '\t'; len ++;
		  break;
		case 'r':
		  *p++ = '\r'; len++;
		  break;
		case 'v':
		  *p++ = '\v'; len ++;
		  break;
		case '"':
		  *p ++ = '"'; len ++;
		  break;
	  /* Not yet, as we do not return the length of the string */
		case '0':
		  *p++ = '\0'; len++;
		  break;
		case '\'':
		  *p++ = '\''; len++;
		  break;

		case 'x':
		  x = 0;
		  for (i = 0; i < 2; i ++)
		    {
		      c = getc(fp);
		      if (c == EOF)
			{
			  nasl_perror(NULL, "Unfinished \\x escape sequence (EOF)\n");
			  goto exit_loop;
			}
		      if (c == '\n')
			ctx->line_nb ++;

		      c = tolower(c);
		      if (c >= '0' && c <= '9') 
			x = x * 16 + (c - '0');
		      else if (c >= 'a' && c <= 'f')
			x = x * 16 + 10 + (c - 'a');
		      else
			{
			  nasl_perror(NULL, "Unfinished \\x escape sequence\n");
			  ungetc(c, fp);
			  if (c == '\n')
			    ctx->line_nb --;
			  break;
			}
		    }
		  *p++ = x; len ++;		    
		  break;

		default:
		  nasl_perror(NULL, "Unknown escape sequence \\%c\n", c);
		  *p++ = c; len ++;
		  break;
		}
	    }
	  else
	    {
	      *p++ = c;
	      len ++;
	    }
	  break;

	case ST_IDENT:
	  if (isalnum(c) || c == '_')
	    {
	      st = ST_IDENT;
	      *p++ = c;
	      len ++;
	    }
	  else
	    {
	      ungetc(c, fp);
	      if (c == '\n') 
		ctx->line_nb --;
	      goto exit_loop;
	    }
	  break;

	case ST_ZERO:
	  if (c == 'x' || c == 'X')
	    st = ST_ZEROX;
	  else if (isdigit(c))
	    {
	      if (c <= '7')
		st = ST_OCT;
	      else
		st = ST_DEC;
	      *p ++ = c;
	      len ++;
	    }
	  else
	    {
	      ungetc(c, fp);
	      if (c == '\n')
		ctx->line_nb --;
	      goto exit_loop;
	    }
	  break;

	case ST_ZEROX:
	  if (isxdigit(c))
	    {
	      st = ST_HEX;
	      *p++ = c;
	      len ++;
	    }
	  else
	    {
	      /* This should be a parse error */
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      goto exit_loop;
	    }
	  break;

	case ST_OCT:
	  if (c >= '0')
	    {
	    if (c <= '7')
	      {
		*p++ = c;
		len ++;
		break;
	      }
	    else if (c <= '9')
	      {
		*p++ = c;
		len ++;
		st = ST_DEC;
		break;
	      }
	    }
	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  goto exit_loop;

	case ST_DEC:
	  if (isdigit(c))
	    {
	      *p++ = c;
	      len ++;
	    }
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      goto exit_loop;
	    }
	  break;

	case ST_HEX:
	  if (isxdigit(c))
	    {
	      *p++ = c;
	      len ++;
	    }
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      goto exit_loop;
	    }
	  break;
	    
	case ST_SPACE:
	  if (! isspace(c))
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      st = ST_START;
	    }
	  break;

	case ST_COMMENT:
	  if (c == '\n')
	    st = ST_START;
	  break;

	case ST_SUP_EXCL:
	  if (c == '<')
	    return NOMATCH;
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      if (! isprint(c)) c = '.';
	      fprintf(stderr, "lexer error: invalid token >!%c parsed as >!< %c\n", c, c);
	      return NOMATCH;
	    }
	  break;

	case ST_SUP:
	  if (c == '=')
	    return SUPEQ;
	  else if (c == '<')
	    return MATCH;
	  else if (c == '>')
	    st = ST_R_SHIFT;
	  else if (c == '!')
	    st = ST_SUP_EXCL;
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      return '>';
	    }
	  break;

	case ST_INF:
	  if (c == '=')
	    return INFEQ;
	  else if (c == '<')
	    st = ST_L_SHIFT;
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      return '<';
	    }
	  break;

	case ST_R_SHIFT:
	  if (c == '=')
	    return R_SHIFT_EQ;
	  else if (c == '>')
	    st = ST_R_USHIFT;
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      return R_SHIFT;
	    }
	  /*NOTREACHED*/
	  break;

	case ST_R_USHIFT:
	  if (c == '=')
	    return R_USHIFT_EQ;
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      return R_USHIFT;
	    }
	  /*NOTREACHED*/
	  break;

	case ST_L_SHIFT:
	  if (c == '=')
	    return L_SHIFT_EQ;
	  else
	    {
	      ungetc(c, fp);
	      if (c ==  '\n')
		ctx->line_nb --;
	      return L_SHIFT;
	    }
	  /*NOTREACHED*/
	  break;

	case ST_AND:
	  if (c == '&')
	    return AND;
	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '&';

	case ST_OR:
	  if (c == '|')
	    return OR;
	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '|';

	case ST_NOT:
	  if (c == '=')
	    return NEQ;
	  else if (c == '~')
	    return RE_NOMATCH;
	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '!';

	case ST_EQ:
	  if (c == '=')
	    return EQ;
	  else if (c == '~')
	    return RE_MATCH;
	  else if (c == '>')
	    return ARROW;
	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '='; 

	case ST_PLUS:
	  if (c == '+')
	    return PLUS_PLUS;
	  else if (c == '=')
	    return PLUS_EQ;

	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '+'; 
	  
	case ST_MINUS:
	  if (c == '-')
	    return MINUS_MINUS;
	  else if (c == '=')
	    return MINUS_EQ;

	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '-'; 
	  
	case ST_MULT:
	  if (c == '=')
	    return MULT_EQ;
	  else if (c == '*')
	    return EXPO;
	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '*'; 
	  
	case ST_DIV:
	  if (c == '=')
	    return DIV_EQ;

	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '/'; 
	  
	case ST_MODULO:
	  if (c == '=')
	    return MODULO_EQ;

	  ungetc(c, fp);
	  if (c ==  '\n')
	    ctx->line_nb --;
	  return '%'; 
	  
	}

      if (len >= ctx->maxlen) 
	{
	  int	offs = p - ctx->buffer;
	  char	*buf2;
	  ctx->maxlen += 80;
	  buf2 = erealloc(ctx->buffer, ctx->maxlen + 1);
	  if (buf2 == NULL)
	    {
	      perror("realloc");
	      abort();
	    }
	  p = buf2 + offs;
	  ctx->buffer = buf2;
	}
    }

 exit_loop:
  ctx->buffer[len] = '\0';
  switch (st)
    {
    case ST_START:
    case ST_COMMENT:
    case ST_SPACE:
      return 0;

    case ST_STRING2:
      r = STRING2;
      lvalp->str = estrdup(ctx->buffer);
      return r;
      
    case ST_STRING1:
      r = STRING1;
      lvalp->data.val = emalloc(len+2);
      memcpy(lvalp->data.val, ctx->buffer, len+1);
      lvalp->data.len = len;
      return r;
      
    case ST_IDENT:
      if (strcmp(ctx->buffer, "if") == 0)
	r = IF;
      else if (strcmp(ctx->buffer, "else") == 0)
	r = ELSE;
      else if (strcmp(ctx->buffer, "for") == 0)
	r = FOR;
      else if (strcmp(ctx->buffer, "while") == 0)
	r = WHILE;
      else if (strcmp(ctx->buffer, "repeat") == 0)
	r = REPEAT;
      else if (strcmp(ctx->buffer, "until") == 0)
	r = UNTIL;
      else if (strcmp(ctx->buffer, "foreach") == 0)
	r = FOREACH;
      else if (strcmp(ctx->buffer, "function") == 0)
	r = FUNCTION;
      else if (strcmp(ctx->buffer, "return") == 0)
	r = RETURN;
      else if (strcmp(ctx->buffer, "x") == 0)
	r = REP;
      else if (strcmp(ctx->buffer, "include") == 0)
	r = INCLUDE;
      else if (strcmp(ctx->buffer, "break") == 0)
	r = BREAK;
      else if (strcmp(ctx->buffer, "continue") == 0)
	r = CONTINUE;
      else if (strcmp(ctx->buffer, "local_var") == 0)
	r = LOCAL;
      else if (strcmp(ctx->buffer, "global_var") == 0)
	r = GLOBAL;
      else
	{
	  r = IDENT;
	  lvalp->str = estrdup(ctx->buffer);
	  return r;
	}
      return r;

    case ST_DEC:
      /* -123 is parsed as "-" and "123" so that we can write "4-2" without
       * inserting a white space after the minus operator
       * Note that strtoul would also work on negative integers */
      lvalp->num = x = strtoul(ctx->buffer, NULL, 10);
#if NASL_DEBUG > 1 && defined(ULONG_MAX) && defined(ERANGE)
      if (x == ULONG_MAX && errno == ERANGE)
	nasl_perror(NULL, "Integer overflow while converting %s at or near line %d\n", ctx->buffer, ctx->line_nb);
#endif
      return INTEGER;

    case ST_OCT:
      lvalp->num = x = strtoul(ctx->buffer, NULL, 8);
#if NASL_DEBUG > 1 && defined(ULONG_MAX) && defined(ERANGE)
      if (x == ULONG_MAX && errno == ERANGE)
	nasl_perror(NULL, "Integer overflow while converting %s at or near line %d\n", ctx->buffer, ctx->line_nb);
#endif
      return INTEGER;

    case ST_HEX:
      lvalp->num = x = strtoul(ctx->buffer, NULL, 16);
#if NASL_DEBUG > 1 && defined(ULONG_MAX)
      if (x == ULONG_MAX)
	nasl_perror(NULL, "Possible integer overflow while converting %s at or near line %d\n", ctx->buffer, ctx->line_nb);
#endif
      return INTEGER;

    case ST_ZEROX:
      nasl_perror(NULL, "Invalid token 0x parsed as 0 at line %d\n",
	      ctx->line_nb);
    case ST_ZERO:
      lvalp->num = 0;
      return INTEGER;
    default:
      abort();
    }
}

int
nasllex(lvalp, parm)
     YYSTYPE *lvalp;
     void	*parm;
{

  int	x = mylex(lvalp, parm);
#if 0
  naslctxt	*ctx = parm;
  if (isprint(x))
    fprintf(stderr, "Line %d\t: '%c'\n", ctx->line_nb, x);
  else
    fprintf(stderr, "Line %d\t:  %d\n", ctx->line_nb, x);
#endif
  return x;
}


